import java.io.*;
import java.lang.*;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

import org.bouncycastle.util.encoders.*;

import org.bouncycastle.crypto.*;
import org.bouncycastle.crypto.engines.*;
import org.bouncycastle.crypto.modes.*;
import org.bouncycastle.crypto.params.*;

public class BlowFishMidp extends MIDlet implements CommandListener {

    private Display display = null;
    private boolean encrypted = false;
    
    private String key = "abcdefghijklmnopqrstuvwxyz0123456789";
    private String text = "J2ME Crypto";

    private BufferedBlockCipher bfCipher = null;
    
    private Form mainForm = null;
    
    private StringItem statusItem = new StringItem ("Status = ", "init");
    private StringItem keyItem = new StringItem ("Key = ", key);
    private StringItem textItem = new StringItem ("Text = ", text);

    public static Command encrypt = new Command ("Encrypt", Command.SCREEN, 1);
    public static Command decrypt = new Command ("Decrypt", Command.SCREEN, 2);
    
    
    public BlowFishMidp() throws CryptoException {

	mainForm = new Form("BlowfishMidp");

	mainForm.append (statusItem);
	mainForm.append (textItem);
	mainForm.append (keyItem);
	
	mainForm.addCommand (encrypt);
	mainForm.addCommand (decrypt);
	mainForm.setCommandListener (this);
    }

    
    public void startApp() {
	display = Display.getDisplay(this);
	display.setCurrent(mainForm);
    }
    

    public void pauseApp() {}

    
    public void destroyApp(boolean unconditional) {}


    public void commandAction (Command c, Displayable d) {
	if (c == encrypt && !encrypted) {
	    try {
		textItem.setText (encryptText(key, text));
		statusItem.setText ("encrypted.");
		encrypted = true;
	    }
	    catch (CryptoException ce) {
		throw new RuntimeException (ce.toString());
	    }
	}
	else if (c == decrypt && encrypted) {
	    try {
		textItem.setText (decryptText(key, textItem.getText ()));
		statusItem.setText ("decrypted.");
		encrypted = false;
	    }
	    catch (CryptoException ce) {
		throw new RuntimeException (ce.toString());
	    }
	}
    }


    private String encryptText (String key, String text) throws CryptoException {
	byte[] keyBytes= Hex.decode(key.getBytes()); 
	byte[] ptBytes = text.getBytes();
	
	bfCipher = new PaddedBlockCipher
	    (new CBCBlockCipher
		(new BlowfishEngine()));
	
	bfCipher.init(true, new KeyParameter(keyBytes));
	byte[] result = new byte[bfCipher.getOutputSize(ptBytes.length)];
	int len = bfCipher.processBytes(ptBytes, 0, ptBytes.length, result, 0);
	bfCipher.doFinal(result, len);
	
	return new String(Hex.encode(result));	
    }

    
    private String decryptText(String key, String cipherText) throws CryptoException {
	byte[] keyBytes = Hex.decode(key.getBytes());
	byte[] textBytes = Hex.decode(cipherText.getBytes());

	bfCipher.init(false, new KeyParameter(keyBytes));
	
	byte[] result = new byte[bfCipher.getOutputSize(textBytes.length)];
	int len = bfCipher.processBytes(textBytes, 0, textBytes.length, result, 0);
	bfCipher.doFinal(result, len);
	return new String(result).trim();
    }
}

