package org.bouncycastle.asn1;

import java.io.*;

/**
 * DER IA5String object - this is an ascii string, strictly speaking
 * we don't handle this correctly as we're taking advantage of the fact the
 * default platform encoding is ascii... later!
 */
public class DERIA5String
    extends DERObject
    implements DERString
{
    String  string;

    /**
     * basic constructor - with bytes.
     */
    public DERIA5String(
        byte[]   string)
    {
        this.string = new String(string);
    }

    /**
     * basic constructor - with string.
     */
    public DERIA5String(
        String   string)
    {
        this.string = string;
    }

    public String getString()
    {
        return string;
    }

    void encode(
        DEROutputStream  out)
        throws IOException
    {
        out.writeEncoded(IA5_STRING, string.getBytes());
    }
}
