package org.bouncycastle.asn1;

import java.io.*;
import java.math.BigInteger;

public class DERInteger
    extends DERObject
{
    byte[]      bytes;

    public DERInteger(
        int         value)
    {
        int length = value;
        int size = 1;

        while ((length >>>= 8) != 0)
        {
            size++;
        }

        bytes = new byte[size];

        for (int i = (size - 1); i >= 0; i--)
        {
            bytes[i] = (byte)(value >> i);
        }
    }

    public DERInteger(
        BigInteger   value)
    {
        bytes = value.toByteArray();
    }

    public DERInteger(
        byte[]   bytes)
    {
        this.bytes = bytes;
    }

    public BigInteger getValue()
    {
        return new BigInteger(bytes);
    }

    void encode(
        DEROutputStream out)
        throws IOException
    {
        out.writeEncoded(INTEGER, bytes);
    }
}
