package org.bouncycastle.asn1.x509;

import java.math.*;
import java.util.*;

import org.bouncycastle.asn1.*;

public class DSAParameter
    implements DEREncodable
{
    DERInteger      p, q, g;

    public DSAParameter(
        BigInteger  p,
        BigInteger  q,
        BigInteger  g)
    {
        this.p = new DERInteger(p);
        this.q = new DERInteger(q);
        this.g = new DERInteger(g);
    }

    public DSAParameter(
        DERConstructedSequence  seq)
    {
        Enumeration     e = seq.getObjects();

        p = (DERInteger)e.nextElement();
        q = (DERInteger)e.nextElement();
        g = (DERInteger)e.nextElement();
    }

    public DERInteger getP()
    {
        return p;
    }

    public DERInteger getQ()
    {
        return q;
    }

    public DERInteger getG()
    {
        return g;
    }

    public DERObject getDERObject()
    {
        DERConstructedSequence  seq = new DERConstructedSequence();

        seq.addObject(this.getP());
        seq.addObject(this.getQ());
        seq.addObject(this.getG());

        return seq;
    }
}
