import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

import net.jscience.math.kvm.*;

public class CalculatorMidp extends MIDlet implements CommandListener {
    
    char operator = '=';
    StringItem operand1Item = new StringItem ("", "");
    TextField  operand2Field = new TextField ("", "", 7, TextField.NUMERIC);
    TextField operand2FField = new TextField (".", "", 5, TextField.NUMERIC);

    Display display;
    Form list;
   
    public CalculatorMidp () {
	display = Display.getDisplay (this);

	list = new Form ("Calculator");
	list.append (operand1Item);
	list.append (operand2Field);
	list.append (operand2FField);

	list.addCommand (new Command ("+", Command.SCREEN, 1));
        list.addCommand (new Command ("=", Command.SCREEN, 2));
        list.addCommand (new Command ("-", Command.SCREEN, 3));
        list.addCommand (new Command ("*", Command.SCREEN, 3));
        list.addCommand (new Command ("/", Command.SCREEN, 2));
	list.addCommand (new Command ("CLR", Command.SCREEN, 4));

	list.setCommandListener (this);
    }
    

    
    public void startApp () {
	display.setCurrent (list);
    }


    public void pauseApp () {
    }


    public void destroyApp (boolean unconditional) {
    }
    

    public void commandAction(Command c, Displayable d) {

	if (c.getLabel ().equals ("CLR")) {
	    operator = '=';
	    operand1Item.setText ("");
	    operand2Field.setLabel ("");
	    operand2Field.setString ("");
	    operand2Field.setString ("");
	}
	else {
	    // 1. apply op
	    
	    int op2 = MathFP.toFP 
		(operand2Field.getString () 
		 + "." + operand2FField.getString ());

	    if (operator != '=') {
		int op1 = MathFP.toFP (operand1Item.getText ());
		switch (operator) {
		case '+': op2 = MathFP.add (op1, op2); break;
		case '-': op2 = MathFP.sub (op1, op2); break;
		case '*': op2 = MathFP.mul (op1, op2); break;
		case '/': op2 = MathFP.div (op1, op2); break;
		}
	    }

	    String result = MathFP.toString (op2);
	    operator = c.getLabel ().charAt (0);

	    if (operator != '=') {
		operand1Item.setText (MathFP.toString (op2)); 
		operand2Field.setLabel (c.getLabel ());
		operand2Field.setString ("");
		operand2FField.setString ("");
	    }
	    else {
		operand1Item.setText ("");
		operand2Field.setLabel ("");
		int cut = result.indexOf (".");
		if (cut == -1) { 
		    operand2Field.setString (result);
		    operand2FField.setString ("");
		}
		else {
		    operand2Field.setString (result.substring (0, cut));
		    operand2FField.setString (result.substring (cut+1));
		}
	    }
	}
    }

    public static void main (String [] argv) {
	new CalculatorMidp ().startApp ();
    }
}











