import java.io.*;
import java.util.Vector;

import org.kxml.*;
import org.kxml.parser.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;


public class KxmlNewsreader extends MIDlet implements CommandListener {

    static final String URL = "http://newsforge.com/newsforge.xml";
    static final String TITLE = "NewsForge";
	
    Vector descriptions = new Vector ();
    List newsList = new List (TITLE, Choice.IMPLICIT);
    TextBox textBox = new TextBox ("", "", 256, TextField.ANY);
    Display display;

    Command backCmd = new Command ("Back", Command.BACK, 0);

    class ReadThread extends Thread {
   
	public void run () {
	    try {
		HttpConnection httpConnection = 
		    (HttpConnection) Connector.open (URL);
		
		XmlParser parser = new XmlParser (new InputStreamReader 
		    (httpConnection.openInputStream ()));
		
		parser.skip ();
		parser.read (Xml.START_TAG, null, "backslash");
		
		while (true) {
		    parser.skip ();
		    
		    if (parser.peek (Xml.START_TAG, null, "story"))
			readStory (parser);
		    else if (parser.peek (Xml.END_TAG, null, "backslash")) { 
			parser.read ();
			break;
		    }
		    else throw new RuntimeException 
			("XML error: Unexpected event: "+ parser.peek ());
		}   
	    }
	    catch (Exception e) {
		newsList.append ("Error", null);
		descriptions.addElement (e.toString ());
	    }
	}
	

	/** Read a story and append it to the list */

	void readStory (XmlParser parser) throws IOException {
	    parser.read (Xml.START_TAG, "", "story");
	    
	    String title = null;
	    String description = null;

	    while (true) {
		parser.skip ();
		ParseEvent event = parser.peek ();
		
		if (event.getType () == Xml.START_TAG) {
		    //System.out.println ("field: "+event);
		    
		    String name = event.getName ();
		    parser.read ();
		    String text = parser.readText ();
		    parser.read (Xml.END_TAG, "", name);

		    if (name.equals ("title"))
			title = text;
		    else if (name.equals ("description"))
			description = text;
		}
		else if (event.getType () == Xml.END_TAG) {
		    parser.read (Xml.END_TAG, "", "story");
		    break;
		}
		else throw new RuntimeException ("unexpected event: "+event);
	    }
	    
	    if (title != null) { 
		descriptions.addElement (description != null ? description : title);
		newsList.append (title, null);
	    }
	}
    }

    public void startApp () {
	if (display == null) {
	    display = Display.getDisplay (this);
	    newsList.setCommandListener (this);
	    textBox.setCommandListener (this);
	    textBox.addCommand (backCmd);
	    new ReadThread ().start ();
	}
	display.setCurrent (newsList);
    }


    public void pauseApp () {
    }



    public void commandAction (Command c, Displayable d) {

	if (c == List.SELECT_COMMAND) {
	    
	    String text = (String) descriptions.elementAt 
		(newsList.getSelectedIndex ());
		 
	    if (textBox.getMaxSize () < text.length ()) 
		textBox.setMaxSize (text.length ());
	    
	    textBox.setString (text);
	    display.setCurrent (textBox);
	}
	else if (c == backCmd)
	    display.setCurrent (newsList);
    }
 
    public static void main (String [] argv) {
	new KxmlNewsreader ().startApp ();
    }
    

    public void destroyApp (boolean really) {
    }


}



