import java.io.*;
import java.util.Vector;
import java.util.Hashtable;

import tinyxml.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;


public class TinyNewsreader extends MIDlet implements CommandListener {

    static final String URL = "http://newsforge.com/newsforge.xml";
    static final String TITLE = "NewsForge";
	
    Vector descriptions = new Vector ();
    List newsList = new List (TITLE, Choice.IMPLICIT);
    TextBox textBox = new TextBox ("", "", 256, TextField.ANY);
    Display display;

    Command backCmd = new Command ("Back", Command.BACK, 0);

    class NewsHandler extends HandlerBase {
	StringBuffer title;
	StringBuffer description;
	String currentElement = "";
	
	public void elementStart (String name, Hashtable attributes) {
	    //System.out.println ("start:"+name);
	    currentElement = name;
	    if (name.equals ("story")) {
		title = new StringBuffer ();
		description = new StringBuffer ();
	    }
		
	}
	
	public void charData (String s) {
	    if (currentElement.equals ("title")) 
		title.append (s);
	    else if (currentElement.equals ("description"))
		description.append (s);
	}

	public void elementEnd (String name) {
	    //System.out.println ("end:"+name);
	    currentElement = "";
	    if (name.equals ("story")) {
		newsList.append (title.toString (), null);
                String d = description.toString ();
		descriptions.addElement (d.length () == 0 ? title.toString () : d);
	    }
	}
    }

    
    public void readNews () {
	try {
	    HttpConnection httpConnection = 
		(HttpConnection) Connector.open (URL);

	    InputStream is = httpConnection.openInputStream ();
	    
	    ByteArrayOutputStream bos = new ByteArrayOutputStream ();
	    byte [] buf = new byte [256];

	    while (true) {
		int cnt = is.read (buf, 0, 256);
		if (cnt < 0) break;
		bos.write (buf, 0, cnt);
	    }
	    
	    XMLParser parser = new XMLParser ();
	    //	    System.out.println (bos.toString ());
	    parser.setInputStream 
		(new XMLInputStream (new String (bos.toByteArray ())));
	    parser.setDocumentHandler (new NewsHandler ());
	    parser.parse ();
	}
	catch (ParseException e) {
	    newsList.append ("Error", null);
	    descriptions.addElement (e.toString ());
	}
	catch (IOException e) {
	    newsList.append ("Error", null);
	    descriptions.addElement (e.toString ());
	}
    }
    



    public void startApp () {
	display = Display.getDisplay (this);
	display.setCurrent (newsList);
	newsList.setCommandListener (this);
	textBox.setCommandListener (this);
	textBox.addCommand (backCmd);
	if (descriptions.size () == 0) readNews ();
    }


    public void pauseApp () {
    }



    public void commandAction (Command c, Displayable d) {

	if (c == List.SELECT_COMMAND) {
	    
	    String text = (String) descriptions.elementAt 
		(newsList.getSelectedIndex ());
		 
	    if (textBox.getMaxSize () < text.length ()) 
		textBox.setMaxSize (text.length ());
	    
	    textBox.setString (text);
	    display.setCurrent (textBox);
	}
	else if (c == backCmd)
	    display.setCurrent (newsList);
    }
 
    

    public void destroyApp (boolean really) {
    }


}



