import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;


public class TeleTransfer extends MIDlet implements ItemStateListener, CommandListener {

    Form mainForm = new Form ("TeleTransfer");
    
    TextField receiverName = new TextField ("Receiver Name", "", 20, TextField.ANY);
    TextField receiverAccount = new TextField ("Receiver Account#", "", 8, TextField.NUMERIC);
    TextField amountWhole = new TextField ("Dollar", "", 5, TextField.NUMERIC);
    TextField amountFraction = new TextField ("Cent", "", 2, TextField.NUMERIC);

    ChoiceGroup currency = new ChoiceGroup ("Currency", Choice.EXCLUSIVE, new String[] {"USD", "EUR", "JPY"}, null);
    
    Display display = Display.getDisplay (this);

    static final Command sendCommand = new Command ("Send", Command.SCREEN, 1);
    static final Command clearCommand = new Command ("Clear", Command.SCREEN, 2);
    static final Command exitCommand = new Command ("Exit", Command.EXIT, 1);

    public TeleTransfer () {
	mainForm.append (receiverName);
	mainForm.append (receiverAccount);
	mainForm.append (amountWhole);
	mainForm.append (amountFraction);
	mainForm.append (currency);
	mainForm.setItemStateListener (this);
	mainForm.addCommand (sendCommand);
	mainForm.addCommand (clearCommand);
	mainForm.addCommand (exitCommand);
	mainForm.setCommandListener (this);
    }
    
    public void startApp () {
	display.setCurrent (mainForm);
    }

    public void resetTransferInformation () {
	receiverName.setString ("");
	receiverAccount.setString ("");
	amountWhole.setString ("");
	amountFraction.setString ("");
    }
    
    public void sendTransferInformation () {
	
	Alert alert = new Alert ("Send");
	alert.setString ("transfer " + amountWhole.getString () + "." + amountFraction.getString () + " " 
			 + amountWhole.getLabel ()
			 + "\nto Acc#" + receiverAccount.getString () + "\nof " + receiverName.getString ());
	
	alert.setTimeout (2000);
	display.setCurrent (alert);
	
	resetTransferInformation ();
    }
    
    public void pauseApp () {
    }
    
    public void destroyApp (boolean unconditional) {
    }
    
    public void itemStateChanged (Item item) {
	if (item == currency) {
	    int index = currency.getSelectedIndex ();
	    
	    switch (index) {
	    case 0: 
		amountWhole.setLabel ("Dollar");
		amountFraction.setLabel ("Cent");
		break;
	    case 1:
		amountWhole.setLabel ("Euro");
		amountFraction.setLabel ("Cent");
		break;
	    case 2:
		amountWhole.setLabel ("Yen");
		amountFraction.setLabel ("Sen");
	    }
	}
    }
    
    public void commandAction (Command c, Displayable d) {
	if (c == exitCommand) {
	    notifyDestroyed();
	}
	else if (c == sendCommand) {
	    sendTransferInformation ();
	}
	else if (c == clearCommand) {
	    resetTransferInformation ();
	}
    }
}






