import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;


class CurrencyList extends List implements CommandListener {
    
    TeleTransfer teleTransfer;
    static final String [] CURRENCY_NAMES = {"Dollar", "Euro", "Yen"};
    static final String [] CURRENCY_FRACTIONS = {"Cent", "Cent", "Sen"};

    public CurrencyList (TeleTransfer teletransfer) {
	super ("Select Currency", Choice.IMPLICIT);

	this.teleTransfer = teletransfer;

	try {
	    append ("USD", Image.createImage ("/Dollar.png"));
	    append ("EUR", Image.createImage ("/Euro.png"));
	    append ("JPY",  Image.createImage ("/Yen.png"));
	} 
	catch (java.io.IOException x) {
	    throw new RuntimeException ("Images not found");
	}
	setCommandListener (this);
    }

    
    public void commandAction (Command c, Displayable d) {
	if (c == List.SELECT_COMMAND) {
	    teleTransfer.amountWhole.setLabel (CURRENCY_NAMES [getSelectedIndex ()]);
	    teleTransfer.amountFraction.setLabel (CURRENCY_FRACTIONS [getSelectedIndex ()]);
	    teleTransfer.back ();
	}
    }
}


class TransferReason extends TextBox implements CommandListener {
    
    static final Command okCommand = new Command ("OK", Command.BACK, 1);
    static final Command clearCommand = new Command ("Clear", Command.SCREEN, 2);

    TeleTransfer teleTransfer;
 
    public TransferReason (TeleTransfer teleTransfer) {
	super ("Transfer Reason", "", 50, TextField.ANY);
	this.teleTransfer = teleTransfer;

	addCommand (okCommand);
	addCommand (clearCommand);
	setCommandListener (this);
    }

    public void commandAction (Command c, Displayable d) {
	if (c == clearCommand) {
	    setString ("");
	}
	else if (c == okCommand) {
	    teleTransfer.back ();
	}
    }
}


public class TeleTransfer extends MIDlet implements CommandListener {

    static final Command sendCommand = new Command ("Send", Command.SCREEN, 2);    
    static final Command clearCommand = new Command ("Clear", Command.SCREEN, 2);
    static final Command exitCommand = new Command ("Exit", Command.SCREEN, 1);
    static final Command currencyCommand = new Command ("Currency", Command.SCREEN, 2);
    static final Command reasonCommand = new Command ("Reason", Command.SCREEN, 2);

    Form mainForm = new Form ("TeleTransfer");

    TextField receiverName = new TextField ("Receiver Name", "", 20, TextField.ANY); 
    TextField receiverAccount = new TextField ("Receiver Account#", "", 8, TextField.NUMERIC);
    TextField amountWhole = new TextField ("Dollar", "", 6, TextField.NUMERIC);
    TextField amountFraction = new TextField ("Cent", "", 2, TextField.NUMERIC);	
 	
    CurrencyList currencyList = new CurrencyList (this);
    TransferReason transferReason = new TransferReason (this);
    Display display;
    
    
    public TeleTransfer () {
	mainForm.append (receiverName);
	mainForm.append (receiverAccount);
	mainForm.append (amountWhole);
	mainForm.append (amountFraction); 

	mainForm.addCommand (currencyCommand);
	mainForm.addCommand (reasonCommand);
	mainForm.addCommand (sendCommand);
	mainForm.addCommand (exitCommand);
	mainForm.setCommandListener (this);
    }

    public void startApp () {
	display = Display.getDisplay (this);
	display.setCurrent (mainForm);
    }
    

    
    public void resetTransferInformation () {
	receiverName.setString ("");
	receiverAccount.setString ("");
	amountWhole.setString ("");
	amountFraction.setString ("");
	transferReason.setString ("");
    }
     

    public void sendTransferInformation () {
	Alert alert = new Alert ("Send");
	alert.setString ("transfer " + amountWhole.getString () + "." + amountFraction.getString () + " " + amountWhole.getLabel ()
	    + "\nto Acc#" + receiverAccount.getString () + "\nof " + receiverName.getString ());
	alert.setTimeout (2000);
	display.setCurrent (alert);
	resetTransferInformation ();
    }

    
    public void pauseApp () {
    }
    
    public void destroyApp (boolean unconditional) {
    }

    public void back () {
	display.setCurrent (mainForm);
    }

    public void commandAction (Command c, Displayable d) {
	if (c == exitCommand) {
	    notifyDestroyed();
	}
	else if (c == sendCommand) {
	    sendTransferInformation ();
	}
	else if (c == clearCommand) {
	    resetTransferInformation ();
	}
	else if (c == currencyCommand) {
	    display.setCurrent (currencyList);
	}
	else if (c == reasonCommand) {
	    display.setCurrent (transferReason);
	}
    }
}







