import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

public class ImageButton extends Component  {
    
    Image image;
    String command;
    Vector listeners = new Vector ();
        
    public ImageButton (Image image, String command) {
        this.image = image;
        this.command = command;

        enableEvents(AWTEvent.MOUSE_EVENT_MASK);
    }


    public void addActionListener (ActionListener listener) {
        listeners.addElement (listener);
    }

    
    
    public void removeActionListener (ActionListener listener) {
        listeners.removeElement (listener);
    }

    
    public void paint (Graphics g) {
        Dimension dim = getSize();
        int w = image.getWidth (this);
        int h = image.getHeight (this);

        g.drawImage (image, 
                     (dim.width - w) / 2, 
                     (dim.height - h) / 2, 
                     this);
        Color fg = g.getColor ();
        g.setColor (fg);
        g.drawRoundRect (0, 0, dim.width-1, dim.height-1, 4, 4);
    }
    
    
    public Dimension getMinimumSize() {
        return new Dimension (image.getWidth (null), 
                              image.getHeight (null));
    }


    public Dimension getPreferredSize() {
        return getMinimumSize();
    }

    
    public void processMouseEvent(MouseEvent e)  {
        
        if (e.getID() == MouseEvent.MOUSE_CLICKED) {
            
            ActionEvent ae = new ActionEvent 
                (this, ActionEvent.ACTION_PERFORMED, command);

            for (int i = 0; i < listeners.size (); i++) 
                ((ActionListener) listeners.elementAt (i))
                    .actionPerformed (ae);
        }
        
        super.processMouseEvent(e);
    }
}






