import java.io.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;


import javax.microedition.io.*;

import javax.microedition.midlet.*;


public class PdapChat extends MIDlet implements ActionListener, Runnable {

    Frame frame = new Frame ("PdapChat");

    java.awt.List list = new java.awt.List ();
    TextField text = new TextField ();
    Button configButton = new Button ("Config");
    Button submitButton = new Button ("Submit");

    int count = -1;

    Timer timer;

    String host = "http://localhost:8080/";
    String nick = "guest";


    class ConfigDialog extends Dialog implements ActionListener {

	TextField hostField = new TextField (host);
	TextField nickField = new TextField (nick);

	Button connectButton = new Button ("Connect");
	Button abortButton = new Button ("Abort");

	ConfigDialog () {
	    super (frame, "Configuration", true);

	    Panel labels = new Panel (new GridLayout (0, 1));
	    Panel fields = new Panel (new GridLayout (0, 1));
	    Panel buttons = new Panel ();

	    add ("West", labels);
	    add ("Center", fields);
	    add ("South", buttons);

	    labels.add (new Label ("host:"));
	    labels.add (new Label ("nick:"));

	    fields.add (hostField);
	    fields.add (nickField);

	    connectButton.addActionListener (this);
	    buttons.add (connectButton);

	    abortButton.addActionListener (this);
	    buttons.add (abortButton);
	    
	    pack ();
	}

	public void actionPerformed (ActionEvent ev) {
	    if (ev.getSource () == connectButton) {
		host = hostField.getText ();
		nick = nickField.getText ();
		connect ();
	    }

	    setVisible (false);
	}
    }
    


    class RefreshTask extends TimerTask {

	public void run () {

	    try {
		Toolkit.getDefaultToolkit ()
		    .getSystemEventQueue ()
		    .invokeAndWait (new Runnable () {
			    public void run () {
				transfer (null);
			    }
			}
				    );
	    }
	    catch (Exception e) {
	    }
	}
    }




    static String readLine (Reader reader) throws IOException {
	StringBuffer buf = new StringBuffer ();

	while (true) { 
	    int c = reader.read ();
	    if (c == -1) {
		if (buf.length () == 0) return null;
		break;
	    }
    
	    if (c == '\n') break;
	    if (c != '\r') buf.append ((char) c);
	}
	return buf.toString ();
    }
    

    
    public PdapChat () {
	
	frame.add ("Center", list);

	Panel input = new Panel (new BorderLayout ());
	frame.add ("South", input);
	input.add ("Center", text);

	Panel buttons = new Panel ();
	input.add ("South", buttons);

	buttons.add (submitButton);
	buttons.add (configButton);

	submitButton.addActionListener (this);
	configButton.addActionListener (this);

	frame.addWindowListener (new WindowAdapter () {
		public void windowClosing (WindowEvent e) {
		    destroyApp (true);
		    notifyDestroyed ();
		}
	    });

	
	frame.pack ();
    }


    void configure () {
	disconnect ();
	new ConfigDialog ().show ();
    }


    void connect () {
	disconnect ();

	if (transfer (null)) {
	    timer = new Timer ();
	    timer.schedule (new RefreshTask (), 0, 4000); 
	}
    }


    void disconnect () {
	if (timer != null) {
	    timer.cancel ();
	    timer = null;
	}
    }


    /** implementation of runnable */

    public void run () {
	transfer (null);
    }


    boolean transfer (String submit) { // if null, just read
	try {
	    Connection connection = Connector.open 
		(host + "/?start="+count, 
		 submit != null ? Connector.READ_WRITE : Connector.READ);

	    Writer writer = null;
	    
	    if (submit != null) {
		// ******** Set Method to POST here!!!!!!!!!!!!!
		
		writer = new OutputStreamWriter 
		    (((StreamConnection) connection).openOutputStream ());
 
		writer.write ("nick="+nick + "\r\n");
		writer.write ("text="+submit+"\r\n");
		writer.write ("\r\n");
		writer.flush ();
	    }

	    Reader reader = new InputStreamReader 
		(((StreamConnection) connection).openInputStream ());

	    count = Integer.parseInt (readLine (reader));
	    while (true) {
		String s = readLine (reader);
		if (s == null || s.length () == 0) break;
		addLine (s);
	    }		

	    if (submit != null)	
		writer.close ();

	    reader.close ();
	    connection.close ();

	    return true;
	}
	catch (Exception e) {
	    addLine (e.toString ());
	    disconnect ();
	    return false;
	}
    }

    public void addLine (String l) {
	list.add (l);
    }
    

    public void actionPerformed (ActionEvent event) {
	if (event.getSource () == configButton)
	    configure ();
	else {
	    transfer (text.getText ());
	    text.setText ("");
	} 

    }

    public void startApp () {
	frame.show ();
	if (timer == null) configure ();
    }

    public void pauseApp() {
    }
   

    public void destroyApp (boolean unconditional) {
	frame.setVisible (false);
	disconnect ();
    }
}
