
import java.io.*;
import javax.microedition.io.*;

import java.awt.*;
import java.awt.event.*;

import javax.microedition.midlet.*;

public class PdapTerminal extends MIDlet implements ActionListener {


    Frame frame = new Frame ();
    TextField urlField = new TextField ("");
    List incoming = new List ();
    TextField sendField = new TextField ();
    
    Button connectButton = new Button ("connect");
    Button sendButton = new Button ("send");


    Handler handler;


    class Appender implements Runnable {
	String data;
	Appender (String data) {
	    this.data = data;
	}

	public void run () {
	    int i0 = data.indexOf ('\r');

	    if (i0 == -1) i0 = data.length ();

	    incoming.replaceItem 
		(incoming.getItem (incoming.getItemCount () - 1) 
		 + data.substring (0, i0), incoming.getItemCount ()-1);
	    i0++;
	    while (i0 <= data.length ()) {
		int i = data.indexOf ('\r', i0);
		if (i == -1) i = data.length ();
		incoming.add (data.substring (i0, i));
		i0 = i+1;
	    }
	}
    }	    



	    
    class Handler extends Thread {

	StreamConnection connection;
	InputStream in;
	OutputStream out;
	boolean leave;

	public Handler (String url) throws IOException {

	    connection = (StreamConnection) Connector.open 
		(url, Connector.READ_WRITE, true);

	    out = connection.openOutputStream ();
	    in = connection.openInputStream ();

	    incoming.add ("opened: "+urlField.getText ());
	    incoming.add ("");

	    this.connection = connection;
	}


	public void run () {
	    
	    StringBuffer buf = new StringBuffer ();
	    
	    try {
		while (!leave) {

		    do {
			int i = in.read ();

			if (i == -1) disconnect ();
			else if (i == 255) {
			    int cmd = in.read ();
			    if (cmd == 255)
				buf.append ((char) 255);
			    else {
				int opt = in.read ();

				if (cmd == 0xfd || cmd == 0x0fb) {
				
				    out.write (255);
				    out.write (cmd == 0xfd ? 252 : 254);
				    out.write (opt);
				    out.flush ();
				}
			    }
			}
			else if (i == '\r' ||i >= ' ')   
			    buf.append ((char) i);
		    }
		    while (!leave && in.available () > 0 
			   && buf.length () < 1024);

		    show (buf.toString ());

		    buf.setLength (0);
		}
	    }
	    catch (Exception e) {
		if (!leave) incoming.add (e.toString ());
		disconnect ();
	    }
	}
    }


    public void show (String s) {
	try {
	    Toolkit.getDefaultToolkit ().getSystemEventQueue ()
		.invokeAndWait (new Appender (s));
	}
	catch (Exception e) {
	    throw new RuntimeException ("Rethrown: "+e);
	}
    }



    public PdapTerminal () {
	frame = new Frame ("PdapTerminal");
	
	frame.addWindowListener (new WindowAdapter () {
		public void windowClosing (WindowEvent e) {
		    destroyApp (true);
		    notifyDestroyed ();
		}
	    });
	

	connectButton.addActionListener (this);
	
	Panel topPanel = new Panel (new BorderLayout ());
	topPanel.add ("Center", urlField);
	topPanel.add ("East", connectButton);
	
	sendButton.addActionListener (this);
	
	Panel bottomPanel = new Panel (new BorderLayout ());
	bottomPanel.add ("Center", sendField);
	bottomPanel.add ("East", sendButton);

	frame.add ("North", topPanel);
	frame.add ("Center", incoming);
	frame.add ("South", bottomPanel);
	
	frame.pack ();
    }


    public void startApp () {
	frame.show ();
    }


    public void actionPerformed (ActionEvent event) {

	try {
	    if (event.getSource () == sendButton && handler != null) {
		handler.out.write (sendField.getText ().getBytes ());
		handler.out.write (13);
		handler.out.write (10);
		handler.out.flush ();
		sendField.setText ("");
	    }
	    else if (event.getSource () == connectButton) {
		disconnect ();
		handler = new Handler (urlField.getText ());
		handler.start ();
	    }
	}
	catch (Exception e) {
	    incoming.add (e.toString ());
	    incoming.add ("");
	    disconnect ();
	}
    }


    public void disconnect () {
	if (handler != null) {
	    handler.leave = true;
	    show ("disconnected!\r");
	    try {
		handler.connection.close ();
		handler.in.close ();
		handler.out.close ();
	    }
	    catch (IOException e) {
	    }
	    handler = null;
	}
    }

    public void pauseApp() {
    }


    public void destroyApp (boolean unconditional) {
	disconnect ();
	frame.setVisible (false);
    }
}
