import java.io.*;

import javax.microedition.midlet.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;


public class MidpTerminal extends MIDlet implements CommandListener {


    class Handler extends Thread {

	StreamConnection connection;
	InputStream in;
	OutputStream out;
	boolean leave;

	public Handler (String url) throws IOException {

	    connection = (StreamConnection) Connector.open 
		(url, Connector.READ_WRITE, true);

	    out = connection.openOutputStream ();
	    in = connection.openInputStream ();

	    show ("opened: "+urlField.getString () + "\r");

	    this.connection = connection;
	}


	public void run () {
	    
	    StringBuffer buf = new StringBuffer ();
	    
	    try {
		while (!leave) {

		    do {
			int i = in.read ();
	
			if (i == -1) disconnect ();
			else if (i == 0x0ff) {
			    int cmd = in.read ();
			   
			    if (cmd == 0x0ff)
				buf.append ((char) 0x0ff);
			    else {
				int opt = in.read ();

				if (cmd == 0xfd || cmd == 0x0fb) {
				
				    out.write (0x0ff);
				    out.write (cmd == 0xfd ? 252 : 254);
				    out.write (opt);
				    out.flush ();
				
				}
			    }
			}
			else if (i == '\r' || i >= ' ')   
			    buf.append ((char) i);
		    }
		    while (!leave && in.available () > 0 && buf.length () < 1024);

		    show (buf.toString ());

		    buf.setLength (0);
		}
	    }
	    catch (Exception e) {
		if (!leave) show (e.toString () + "\r");
		disconnect ();
	    }
	}
    }


    List incoming = new List ("MidpTerminal", Choice.IMPLICIT);

    TextBox urlField = new TextBox 
	("Connect to:", "socket://kiew.uni-dortmund.de:23", 100, TextField.ANY);

    TextBox sendField = new TextBox ("Send:", "", 100, TextField.ANY);

    Command connectCmd = new Command ("Connect", Command.SCREEN, 1);
    Command sendCmd = new Command ("Send", Command.SCREEN, 1);
    Command okCmd = new Command ("Ok", Command.OK, 1);
    Command abortCmd = new Command ("Abort", Command.CANCEL, 1);

    Handler handler = null;
    Display display;

    public MidpTerminal () {
	urlField.addCommand (okCmd);
	urlField.addCommand (abortCmd);
	urlField.setCommandListener (this);

	sendField.addCommand (okCmd);
	sendField.addCommand (abortCmd);
	sendField.setCommandListener (this);

	incoming.addCommand (connectCmd);
	incoming.addCommand (sendCmd);
	incoming.setCommandListener (this);

	incoming.append ("", null);
    }


    public void startApp () {
	display = Display.getDisplay (this);
	display.setCurrent (urlField);
    }


    public void show (String data) {
	int i0 = data.indexOf ('\r');

	//System.out.println ("Adder: cr index is: "+i0);
	if (i0 == -1) i0 = data.length ();

	incoming.set
	    (incoming.size ()-1, 
	     incoming.getString (incoming.size () - 1) 
	     + data.substring (0, i0), null);
	i0++;
	while (i0 <= data.length ()) {
	    int i = data.indexOf ((char) 13, i0);
	    if (i == -1) i = data.length ();
	    incoming.append (data.substring (i0, i), null);
	    i0 = i+1;
	}
    }


    public void commandAction (Command c, Displayable d) {

	try {
	    if (c == connectCmd) 
		display.setCurrent (urlField);
	    else if (c == sendCmd && handler != null) 
		display.setCurrent (sendField);
	    else if (c == abortCmd) 
		display.setCurrent (incoming);
	    else if (c == okCmd) {
		display.setCurrent (incoming);

		if (d == sendField && handler != null) {
		    handler.out.write (sendField.getString ().getBytes ());
		    handler.out.write (13);
		    handler.out.write (10);
		    handler.out.flush ();
		    sendField.setString ("");
		}
		else if (d == urlField) {
		    
		    disconnect ();
		    handler = new Handler (urlField.getString ());
		    handler.start ();
		}
	    }
	}
	catch (Exception e) {
	    show (e.toString ());
	    disconnect ();
	}
    }

    
    public void pauseApp () {
    }
    

    public void disconnect () {
	if (handler != null) {
	    handler.leave = true;
	    show ("disconnected!\r");
	    try {
		handler.connection.close ();
		handler.in.close ();
		handler.out.close ();
	    }
	    catch (IOException e) {
	    }
	    handler = null;
	}
    }


    public void destroyApp (boolean unconditional) {
	disconnect ();
    }


}
