import javax.microedition.rms.*;
import java.util.*;
import java.io.*;
import java.util.*;


public class LogStorage {

    RecordStore days;

    
    public static int dateToInt (Date date) {
        Calendar c = Calendar.getInstance ();
        c.setTime (date);
        return (c.get (Calendar.YEAR) << 16)
            | ((c.get (Calendar.MONTH)-Calendar.JANUARY+1) << 8)
            | (c.get (Calendar.DAY_OF_MONTH));
    }

    /*
    public static int intToDate (int yymd) {
        
    }
    */



    public LogStorage () throws RecordStoreException {
        days = RecordStore.openRecordStore ("BloodSugarLog", true);
    }


    /** if the date is not found, the negated index index where the
        date should be inserted is returned */
        
    public int getIndex (int date) throws RecordStoreException {

        int i = 1;
        int j = days.getNumRecords ();
        int k;
        int dateK;

        while (i <= j) {
            k = (i + j) / 2;
            dateK = getDate (k);
            if (date == dateK) return k;
            else if (date > dateK) i = k+1;
            else j = k-1;
        }
                
        return -i;
    }


    /** Helper method for binary search */

    int getDate (int index) throws RecordStoreException {
        byte[] buf = days.getRecord (index);
        return ((((int) buf [0]) & 0x0ff) << 24)
            | ((((int) buf [1]) & 0x0ff) << 16)
            | ((((int) buf [2]) & 0x0ff) << 8)
            | ((((int) buf [3]) & 0x0ff));
    }


    public DayLog getDayLog (int date) throws RecordStoreException, IOException  {
        int index = getIndex (date);

        return (index < 0)
            ? new DayLog (date)
                : new DayLog (days.getRecord (index));
    }

    
    /** Sets the DayLog object for the given date */

    public void storeDayLog (DayLog dayLog) throws RecordStoreException, IOException {
        int index = getIndex (dayLog.getDate ());

        byte [] target = dayLog.getByteArray ();

        if (index < 0) {
            index = -index;
            
            int num = days.getNumRecords ();

            if (index > num) {
                days.addRecord (target, 0, target.length);
                return;
            }

            byte [] buf = days.getRecord (num);
            days.addRecord (buf, 0, buf.length);
            
            for (int i = num; i > index; i++) {
                buf = days.getRecord (i-1);
                days.setRecord (i, buf, 0, buf.length);
            }
                          
        }

        days.setRecord (index, target, 0, target.length);
    }


    public void close () throws RecordStoreException {
        days.closeRecordStore ();
    }    

}




